/*
*******************************************************************************
**
**  This device driver was created by Applilet for the 78K0S/KB1+, 78K0S/KA1+,
**  78K0S/KY1+ 8-Bit Single-Chip Microcontrollers.
**
**  Copyright(C) NEC Electronics Corporation 2002-2006
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	main.c
**  Abstract :	This file implements main function.
**  APIlib :	NEC78K0SKX1+.lib V1.50 [23 Feb. 2006]
**
**  Device :	uPD78F9222
**
**  Compiler :	NEC/CC78K0
**
*******************************************************************************
*/
/*
*******************************************************************************
**  Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "system.h"
#include "ad.h"
#include "int.h"
#include "port.h"
#include "watchdogtimer.h"
#include "lvi.h"
/*
*******************************************************************************
**  MacroDefine
*******************************************************************************
*/
/*
**---------------------------------------------------------------------------
**
**  Abstract:
**	This function implements main function.
**
**  Parameters:
**	None
**
**  Returns:
**	None
**
**---------------------------------------------------------------------------
*/
unsigned int	input0;
unsigned int	input1;
unsigned int	input2;
unsigned int	input3;

unsigned int	input0x;
unsigned int	input1x;
unsigned int	input2x;
unsigned int	input3x;

unsigned int	in_data;
unsigned int	hen_data;
unsigned char	hen_d[16];
unsigned char	ret_flg;
int	tuner;
int	set_data;


unsigned short	ad_data;		/* ADł̎擾l			*/

void	led_port_clear(void)
{
	P4.0=1;
	P4.1=1;
	P4.2=1;
	P4.3=1;
}

void	time_wait(unsigned int time)
{
	while(time!=0){
	time--;
	}
}

void	led_7seg_out(int data)
{
	P12=(P12|0x0e)&((data&0x07)<<1);
	P13=(P13|0x01)&((data&0x08)>>3);
}

void	led_disp(void)
{
		led_port_clear();
		led_7seg_out(input0);
		P4.0=0;P4.1=1;P4.2=1;P4.3=1;
		time_wait(600);
		led_port_clear();
		led_7seg_out(input1);
		P4.0=1;P4.1=0;P4.2=1;P4.3=1;
		time_wait(600);
		led_port_clear();
		led_7seg_out(input2);
		P4.0=1;P4.1=1;P4.2=0;P4.3=1;
		time_wait(600);
		led_port_clear();
		led_7seg_out(input3);
		P4.0=1;P4.1=1;P4.2=1;P4.3=0;
		time_wait(600);
		led_port_clear();
}

unsigned char	key_scan(void)
{
unsigned char	key_no;

	AD_Start(ADChannel0);
	AD_Read(&ad_data);

	key_no=255;
	if((ad_data>=827)&&(ad_data<=929)){
		key_no=1;
	}
	if((ad_data>=680)&&(ad_data<=783)){
		key_no=2;
	}
	if((ad_data>=534)&&(ad_data<=636)){
		key_no=3;
	}
	if((ad_data>=388)&&(ad_data<=490)){
		key_no=4;
	}
	if((ad_data>=241)&&(ad_data<=344)){
		key_no=5;
	}
	if((ad_data>=95)&&(ad_data<=197)){
		key_no=6;
	}

	if(key_no!=255){return key_no;}

	AD_Start(ADChannel1);
	AD_Read(&ad_data);

	key_no=255;
	if((ad_data>=827)&&(ad_data<=929)){
		key_no=7;
	}
	if((ad_data>=680)&&(ad_data<=783)){
		key_no=8;
	}
	if((ad_data>=534)&&(ad_data<=636)){
		key_no=9;
	}
	if((ad_data>=388)&&(ad_data<=490)){
		key_no=10;
	}
	if((ad_data>=241)&&(ad_data<=344)){
		key_no=0;
	}
	if((ad_data>=95)&&(ad_data<=197)){
		key_no=11;
	}

	return key_no;

}

unsigned char	hz_scan(void)
{
unsigned char	hz_no;

	AD_Start(ADChannel2);
	AD_Read(&ad_data);

	if(ad_data>251){
		hz_no=4;
	}
	if((ad_data>=126)&&(ad_data<=251)){
		hz_no=2;
	}
	if(ad_data<126){
		hz_no=1;
	}

	return hz_no;

}

void	input_clear(void)
{
	input0=0;
	input1=0;
	input2=0;
	input3=0;
}

void	suji_set(int key)
{
	if (ret_flg==0){
		input3=input2;
		input2=input1;
		input1=input0;
		input0=key;
	}
	else{
		input_clear();
		input0=key;
		ret_flg=0;
	}
}

void	port_clear(void)
{
	P3.0=1;
	P3.1=1;
	P4.4=1;
	P4.5=0;
	P2.3=1;

}

void	reset_out(void)
{
	P4.5=1;			/* CLEAR */
	time_wait(5);
	P4.5=0;
	time_wait(5);
	P4.4=0;
	P2.3=0;			/* LATCH */
	time_wait(5);
	P4.4=1;
	P2.3=1;
}

void	data_out(void)
{
int	i;

	in_data=input3*1000+input2*100+input1*10+input0;
	if (in_data>1580) {
		in_data=1580;
		input3=1;
		input2=5;
		input1=8;
		input0=0;
	}
	if (in_data<520) {
		in_data=520;
		input3=0;
		input2=5;
		input1=2;
		input0=0;
	}
	in_data=in_data+455;
	set_data=in_data;
	input3x=in_data/1000;
	input2x=(in_data-input3x*1000)/100;
	input1x=(in_data-input3x*1000-input2x*100)/10;
	input0x=in_data-input3x*1000-input2x*100-input1x*10;

	hen_data=input0x;
	for (i=0;i<4;i++){
		hen_d[i]=(char)(hen_data%2);
		hen_data=hen_data >> 1;
	}
	hen_data=input1x;
	for (i=0;i<4;i++){
		hen_d[i+4]=(char)(hen_data%2);
		hen_data=hen_data >> 1;
	}
	hen_data=input2x;
	for (i=0;i<4;i++){
		hen_d[i+8]=(char)(hen_data%2);
		hen_data=hen_data >> 1;
	}
	hen_data=input3x;
	for (i=0;i<4;i++){
		hen_d[i+12]=(char)(hen_data%2);
		hen_data=hen_data >> 1;
	}

	for (i=0;i<16;i++){
		P3.1=~(hen_d[15-i] & 0x01);
		time_wait(5);
		P3.0=0;
		time_wait(5);
		P3.0=1;
	}

	P4.4=0;			/* LATCH */
	time_wait(5);
	P4.4=1;
}

void	tuner_up(void)
{
	tuner++;
	if(tuner>1023){tuner=1023;}
}
void	tuner_dn(void)
{
	tuner--;
	if(tuner<0){tuner=0;}
}

void	tuner_out(void)
{
int	i;

	hen_data=tuner;
	for (i=0;i<10;i++){
		hen_d[i]=(char)(hen_data%2);
		hen_data=hen_data >> 1;
	}

	for (i=0;i<10;i++){
		P3.1=~(hen_d[9-i] & 0x01);
		time_wait(5);
		P3.0=0;
		time_wait(5);
		P3.0=1;
	}

	P2.3=0;			/* LATCH */
	time_wait(5);
	P2.3=1;
}

void	tuner_set(void)
{
	set_data=set_data-1050;
	if(set_data<0){set_data=0;}
	set_data=set_data;
	if(set_data>1023){set_data=1023;}
	tuner=set_data;

}

void	hz_up(void)
{

	in_data=input3*1000+input2*100+input1*10+input0;
	in_data=((in_data/9)+1)*9;
	if(in_data>1575){in_data=594;}
	input3=in_data/1000;
	input2=(in_data-input3*1000)/100;
	input1=(in_data-input3*1000-input2*100)/10;
	input0=in_data-input3*1000-input2*100-input1*10;

}


void main( void )
{
	unsigned char	scan_key1;
	unsigned char	scan_key2;
	unsigned char	scan_f;
	
	unsigned char	scan_hz1;
	unsigned char	scan_hz2;

	scan_f=0;
	ret_flg=0;
	
	tuner=0;

	input_clear();
	port_clear();
	reset_out();

	/* TODO. add user code */
	while(1){

		scan_key1=key_scan();
		scan_hz1=hz_scan();
		led_disp();
		scan_key2=key_scan();
		scan_hz2=hz_scan();

		if(scan_hz1==scan_hz2){
			switch(scan_hz1){
				case 4:break;
				case 2:tuner_dn();tuner_out();break;
				case 1:tuner_up();tuner_out();break;
			}
		}
		
		if(scan_key1==scan_key2){
			if(scan_key1!=255){
				if(scan_f==0){
						switch(scan_key1){
							case 10:hz_up();
							case 11:data_out();
									ret_flg=1;
									tuner_set();
									tuner_out();
									break;
							case 0:
							case 1:
							case 2:
							case 3:
							case 4:
							case 5:
							case 6:
							case 7:
							case 8:
							case 9:	suji_set(scan_key1);
									break;
						}
						scan_f=1;
				}
			}
		}
		else{
			scan_f=0;
		}

	
	}
}

